""" exF-2.py
AE3M33UI - Artificial Intelligence course, FEE CTU in Prague

Exercise F-2: ROC curve
"""

import numpy as np
from mpg import *
from sklearn import metrics, tree, utils, pipeline, linear_model, cross_validation, svm
from mapping import *
from plotting import *


def main():
    # # Load the data
    X, y = load_mpg_for_classification(['disp', 'hp'])
    # Shuffle them before splitting, they are ordered according to year.
    X, y = utils.shuffle(X, y)
    Xtr, Xtst, ytr, ytst = cross_validation.train_test_split(X, y,
                                                             test_size=0.5)

    # # Setup the list of models
    models = []

    # Setup a decision tree
    dt = tree.DecisionTreeClassifier(max_depth=2)
    models.append({'clf': dt, 'descr': 'DT', 'color': 'b'})

    # Setup other models, logistic regression, SVM, ...
    # They can be even pipelines with basis expansion, etc.

    # <YOUR CODE HERE>

    plot_roc(models, Xtr, ytr, Xtst, ytst)


# catch all exceptions
# noinspection PyBroadException
try:
    ion()  # turn interactive mode on so our plots stay open like in matlab
    main()
except:
    import traceback
    traceback.print_exc()  # mimick printing traceback from an exception

ioff()  # turn interactive mode off
show()  # keeps the window(s) open
